package com.flyfish.framework.query;

/**
 * 可构建的
 *
 * @author wangyu
 */
public interface QueryDefinition {

    /**
     * 构建
     *
     * @param <T> 泛型
     * @return 构建结果
     */
    <T> T build();

    /**
     * 修改，此修改会直接接着查询条件进行拼接
     *
     * @return 修改句柄
     */
    QueryMutation mutate();

    /**
     * 会直接添加嵌套查询到当前查询末尾
     *
     * @return 修改句柄
     */
    QueryMutation within();
}
