package com.flyfish.framework.repository;

import com.flyfish.framework.domain.base.Domain;
import com.flyfish.framework.query.Query;
import reactor.core.publisher.Flux;

/**
 * 高层封装的模型操作
 *
 * @author wangyu
 */
public interface ReactiveEntityOperations {

    /**
     * 查询，通过查询条件和类进行精确查询
     *
     * @param query       查询
     * @param entityClass 查询实体类
     * @param <T>         实体类的实例化结果
     * @return 查询结果
     */
    <T extends Domain> Flux<T> find(Query query, Class<T> entityClass);
}
