package com.flyfish.framework.mongodb.query.impl;

import org.springframework.data.mongodb.core.query.Criteria;

import java.util.function.Consumer;
import java.util.function.Function;

/**
 * 监听器，观察者
 *
 * @author wangyu
 */
public interface QueryChainListener {

    /**
     * 等待下一步消费
     *
     * @return 本身
     */
    QueryChainListener waitFor(Consumer<Criteria> consumer);

    /**
     * 触发动作
     *
     * @return 本身
     */
    QueryChainListener fire();
}
